// This file is generated by kconfig_compiler from knights.kcfg.
// All changes you do to this file will be lost.
#ifndef SETTINGS_H
#define SETTINGS_H

#include <kconfigskeleton.h>
#include <kdebug.h>

#include <QtCore/QDateTime>
class Settings : public KConfigSkeleton
{
  public:
    class EnumAnimationSpeed
    {
      public:
      enum type { Instant, Fast, Normal, Slow, COUNT };
    };
    class EnumProtocol
    {
      public:
      enum type { XBoard, GGZ, ICS, None, COUNT };
    };

    static Settings *self();
    ~Settings();

    /**
      Set Theme file for the board
    */
    static
    void setTheme( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "Theme" ) ))
        self()->mTheme = v;
    }

    /**
      Get Theme file for the board
    */
    static
    QString theme()
    {
      return self()->mTheme;
    }

    /**
      Set Moves animation speed
    */
    static
    void setAnimationSpeed( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "animationSpeed" ) ))
        self()->mAnimationSpeed = v;
    }

    /**
      Get Moves animation speed
    */
    static
    int animationSpeed()
    {
      return self()->mAnimationSpeed;
    }

    /**
      Set time limit for the local or white player
    */
    static
    void setPlayerTime( const QDateTime & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "playerTime" ) ))
        self()->mPlayerTime = v;
    }

    /**
      Get time limit for the local or white player
    */
    static
    QDateTime playerTime()
    {
      return self()->mPlayerTime;
    }

    /**
      Set time limit for the computer, remote or black player
    */
    static
    void setOpponentTime( const QDateTime & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "opponentTime" ) ))
        self()->mOpponentTime = v;
    }

    /**
      Get time limit for the computer, remote or black player
    */
    static
    QDateTime opponentTime()
    {
      return self()->mOpponentTime;
    }

    /**
      Set whether both players have the same time limit
    */
    static
    void setSameTime( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "sameTime" ) ))
        self()->mSameTime = v;
    }

    /**
      Get whether both players have the same time limit
    */
    static
    bool sameTime()
    {
      return self()->mSameTime;
    }

    /**
      Set whether time limits are enabled and displayed
    */
    static
    void setTimeEnabled( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "timeEnabled" ) ))
        self()->mTimeEnabled = v;
    }

    /**
      Get whether time limits are enabled and displayed
    */
    static
    bool timeEnabled()
    {
      return self()->mTimeEnabled;
    }

    /**
      Set protocol to be used for communication to opponent
    */
    static
    void setProtocol( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "protocol" ) ))
        self()->mProtocol = v;
    }

    /**
      Get protocol to be used for communication to opponent
    */
    static
    int protocol()
    {
      return self()->mProtocol;
    }

    /**
      Set program to run
    */
    static
    void setProgram( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "program" ) ))
        self()->mProgram = v;
    }

    /**
      Get program to run
    */
    static
    QString program()
    {
      return self()->mProgram;
    }

  protected:
    Settings();
    friend class SettingsHelper;


    // KGameTheme
    QString mTheme;

    // Preferences
    int mAnimationSpeed;
    QDateTime mPlayerTime;
    QDateTime mOpponentTime;
    bool mSameTime;
    bool mTimeEnabled;

    // Protocols
    int mProtocol;
    QString mProgram;

  private:
};

#endif

